<template>
  <div class="event-id-page">
    <!-- <div class="banner">
      <div class="banner__content">
        <div class="banner__info">
          Две недели проездить на поездах между Петербургом и Москвой и узнать, как провезти с собой серф и чучело лося
        </div>
        <div class="banner__image">
          <img src="@/assets/banner.png" alt="">
        </div>
      </div>
    </div> -->
    <section class="section-1">
      <div>
        <div class="left">
          <div class="name">{{ currentEvent && currentEvent.title }}</div>
          <div class="paid">{{ (currentEvent && currentEvent.price) ? `${currentEvent.price} kzt` : 'Free' }}</div>
          <div class="short-desc">{{ currentEvent && currentEvent.shortDescription }}</div>
          <div class="rating">
            <StarRating :rating="currentEvent.rating" />
          </div>
          <div>
            <span class="author">{{ currentEvent && authorName }}</span>
            &nbsp;
            <span class="place">{{ currentEvent && currentEvent.location }}</span>
          </div>
          <div class="friendsAttending" v-if="friendsAttending && friendsAttending.length">
            <span :style="{'font-weight': 'bold'}">
              {{ friendsAttendingParsed }}
            </span>
            {{ friendsAttending.length > 1 ? 'are' : 'is' }} also going!
          </div>
        </div>
        <div class="right">
          <div class="image-container">
            <img ref="img-container" width="100%" height="100%" alt="" src="@/assets/powerful.svg">
          </div>
        </div>
      </div>
    </section>
    <section class="desc">
      <div class="title">
        <span>DESCRIPTION</span>
      </div>
      <div class="content-container">
        <div class="content">
          <div>{{ currentEvent && currentEvent.longDescription }}</div>
          <span class="btn-attend" :class="{'btn-attend--disabled': !isAuth}" @click="attend">{{ this.isAuth ? attendText : 'Login to attend' }}</span>
        </div>
        <div class="vector">
          <img width="100%" height="100%" src="@/assets/nature.svg" alt="">
        </div>
      </div>
      <!-- <div class="button-container">
        <div class="btn-attend-cont">

        </div>
      </div> -->
    </section>
    <div class="see-more-text">See more events</div>
    <div class="event-container">
      <EventList :eventList="prepPopEvents" />
    </div>
    <div class="see-more-text">
      <div class="review-label-container">
        <span>Reviews</span>
        <div class="add-review-btn" :class="{'add-review-btn--disabled':!isAuth}" @click="addReview">{{ isAuth ? 'Add review' : 'Login to add review' }}</div>
      </div>
    </div>
    <section class="reviews">
      <div v-if="reviews && reviews.length">
        <Review v-for="(review, index) in reviews" :key="index" :review="review" />
      </div>
      <div v-if="!reviews || (reviews && !reviews.length)" class="review-empty">
        Empty
      </div>
    </section>
  </div>
</template>
<script>
import EventList from '@/components/events/EventList'
import Review from '@/components/events/Review'
import StarRating from '@/components/events/StarRating'
import axios from 'axios'
import { EVENTS, PROFILE, REVIEW } from '@/store/types'
import { mapGetters } from 'vuex'
export default {
  name: 'EventIdPage',
  components: {
    EventList,
    Review,
    StarRating
  },
  data: () => ({
    friendsAttending: ''
  }),
  computed: {
    ...mapGetters({
      popularEvents: EVENTS.GETTER.GET_POPULAR_EVENTS,
      userData: PROFILE.GETTER.GET_USER_DATA,
      currentEvent: EVENTS.GETTER.GET_CURRENT_EVENT,
      myEvents: EVENTS.GETTER.GET_MY_EVENTS,
      isAuth: PROFILE.GETTER.GET_IS_AUTHORIZED
    }),
    prepPopEvents () {
      return this.popularEvents.slice(0, 4)
    },
    authorName () {
      if (!this.currentEvent || !this.currentEvent.author) return ''
      return `${this.currentEvent.author.firstName} ${this.currentEvent.author.lastName}`
    },
    isAttended () {
      if (!this.currentEvent) return false
      if (this.currentEvent.attendees && this.currentEvent.attendees.find(c => c.id === this.userData.id)) return true
      if (this.myEvents && this.myEvents.find(c => c.id === this.currentEvent.id)) return true
      return false
    },
    attendText () {
      if (this.isAttended) return 'Unattend'
      else return 'Attend'
    },
    reviews () {
      console.log('this.$store.getters[EVENTS.GETTER.GET_EVENT_REVIEWS](this.$route.params.id)', this.$store.getters[EVENTS.GETTER.GET_EVENT_REVIEWS](this.$route.params.id))
      return this.$store.getters[EVENTS.GETTER.GET_EVENT_REVIEWS](this.$route.params.id)
    },
    friendsAttendingParsed () {
      return this.friendsAttending.map(c => c.firstName).join('')
    }
  },
  watch: {
    '$route.params.id': {
      async handler () {
        await this.$store.dispatch(EVENTS.ACTION.LOAD_EVENT_BY_ID, this.$route.params.id)
      }
    }
  },
  methods: {
    async attend () {
      if (!this.isAuth) return
      if (this.isAttended) await this.$store.dispatch(EVENTS.ACTION.UNATTEND_EVENT, { eventId: this.currentEvent.id })
      else await this.$store.dispatch(EVENTS.ACTION.ATTEND_EVENT, { eventId: this.currentEvent.id })
    },
    async addReview () {
      if (!this.isAuth) return
      this.$store.commit(REVIEW.MUTATION.SET_CURRENT_EVENT_ID, this.currentEvent.id)
    }
  },
  async created () {
    await this.$store.dispatch(EVENTS.ACTION.LOAD_EVENT_BY_ID, this.$route.params.id)
    const self = this
    axios.get(`http://localhost:9192/image/get/${this.currentEvent.imageName}`, {
      // responseType: 'blob'
    }).then(response => {
      var blob = response.data.picture
      const imageUrl = `data:image/png;base64,${blob}`
      self.$refs['img-container'].src = imageUrl
    }).catch(err => {
      console.error('error loading image', err)
      self.$refs['img-container'].src = require(`@/assets/powerful.svg`)
    })
    await this.$store.dispatch(EVENTS.ACTION.LOAD_REVIEWS_EVENTS, this.$route.params.id)
    const res = await this.$store.dispatch(EVENTS.ACTION.LOAD_ATTENDING_FRIENDS, { eventId: this.$route.params.id })
    console.log('res friends', res)
    this.friendsAttending = res.data
    // map(c => c.firstName).join('')
  }
}
</script>
<style lang="scss" scoped>
.add-review-btn {
  position: absolute;
  right: 0;
  top: 0;
  background: #FF6392;
  padding: 5px 40px;
  color: white;
  font-weight: bold;
  font-size: 20px;
  cursor: pointer;

  &--disabled {
    opacity: 0.4;
  }
}
.reviews {
  display: flex;
  justify-content: center;
  margin-bottom: 100px;

  & > div {
    display: flex;
    // flex-direction: column;
    justify-content: space-between;
    flex-wrap: wrap;
    max-width: 1200px;
    width: 100%;
  }

  .review-empty {
    margin: 20px 0 60px;
    width: 100%;
    justify-content: center;
  }
}
.banner {
  background: #C2E2FF;
  width: 100%;
  display: flex;
  justify-content: center;
  padding: 22px 0;
  margin-bottom: 80px;

  &__content {
    display: flex;
    max-width: 1069px;
    width: 100%;
    justify-content: space-between;
  }
  &__info {
    font-family: $base_font;
    font-weight: normal;
    font-size: 30px;
    line-height: 40px;
    text-align: center;
    color: #492338;
    text-shadow: 0px 4px 4px rgba(0, 0, 0, 0.25);
    max-width: 543px;
    width: 100%;
    display: flex;
    align-items: center;
  }
  &__image {
    width: 100%;
    max-width: 442px;
    height: 345px;
  }
}
.section-1 {
  display: flex;
  justify-content: center;
  background: #E8F0FF;
  padding: 30px 0;

  & > div {
    max-width: 1200px;
    width: 100%;
    display: flex;
    justify-content: space-between;
  }
  .left {
    max-width: 700px;
    width: 100%;
    text-align: start;
    display: flex;
    flex-direction: column;
    justify-content: center;
    .paid {
      // font-family: Poppins;
      font-style: normal;
      font-weight: 500;
      font-size: 36px;
      line-height: 50px;
      display: flex;
      align-items: flex-end;
      // text-transform: capitalize;
      color: #FF6392;
    }
    .name {
      font-family: Montserrat;
      font-style: normal;
      font-weight: 600;
      font-size: 44px;
      line-height: 66px;
      display: flex;
      // justify-content: center;
      align-items: flex-end;
      text-transform: capitalize;
      // color: #FFE45E;
    }
    .short-desc {
      line-height: 25px;
      font-size: 19px;
      max-width: 500px;
      margin-top: 20px;
    }
    .rating {
      height: 22px;
      margin: 20px 0;
    }
    .author {
      font-family: Montserrat;
      font-style: normal;
      font-weight: 300;
      font-size: 18px;
      line-height: 22px;
      color: #222222;
    }
    .place {
      font-family: Montserrat;
      font-style: normal;
      font-weight: 500;
      font-size: 18px;
      line-height: 22px;
      color: #222222;
      border-bottom: 1px solid black;
    }
  }
  .right {
    .image-container {
      width: 450px;
      height: 380px;
      border-radius: 20px;
      overflow: hidden;
      // opacity: 0.7;
      img {
        object-fit: cover;
      }
    }
  }
}
.desc {
  margin-top: 80px;
  display: flex;
  flex-direction: column;
  align-items: center;
  .title {
    font-family: $base_font;
    max-width: 1200px;
    width: 100%;
    font-weight: normal;
    font-size: 27px;
    line-height: 32px;
    color: #000000;
    margin-bottom: 55px;
    text-align: start;
    letter-spacing: 0.3em;
    & span {
      border-bottom: 7px solid #FF6392;
      padding-bottom: 10px;
    }
  }

  .content-container {
    display: flex;
    justify-content: space-between;
    max-width: 1200px;
    width: 100%;
    align-items: flex-start;
  }

  .content {
    max-width: 700px;
    width: 100%;
    font-weight: normal;
    line-height: 19px;
    // font-weight: 500;
    text-align: start;
    line-height: 1.5em;
    color: #000000;
    // line-height: 35px;
    font-size: 16px;
    padding-bottom: 20px;
    & > div {
      min-height: 400px;
    }
    // border-bottom: 1px solid #BDBDBD;
  }
  .vector {
    max-width: 400px;
    width: 100%;
  }
}
.btn-attend {
  background: #FF6392;
  // box-shadow: 0px 20px 40px #000;
  // border-radius: 69px;
  font-style: normal;
  font-weight: bold;
  font-size: 20px;
  line-height: 19px;
  display: flex;
  align-items: flex-end;
  text-transform: capitalize;
  color: #FFFFFF;
  height: 38px;
  margin-top: 20px;
  cursor: pointer;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  margin-top: 50px;

  &--disabled {
    opacity: 0.4;
  }
}
.see-more-text {
  margin-top: 60px;
  margin-bottom: 40px;
  text-align: center;
  font-weight: normal;
  font-size: 24px;
  line-height: 32px;
  color: #000000;
  position: relative;
  display: flex;
  justify-content: center;

  .review-label-container {
    position: relative;
    width: 100%;
    width: 1200px;
  }
}
.event-container {
  width: 100%;
  display: flex;
  justify-content: center;
  margin-bottom: 80px;
}
.friendsAttending {
  margin-top: 25px;
}
</style>
